# 单元测试

include:
  - local: .gitlab/ci/common.yml

.unit_test:
  rules:
    - if: '$RUN_MODE == "all"'
    - if: '$RUN_MODE == "unit_test"'
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
    - if: '$CI_PIPELINE_SOURCE == "push"'
  #  when: on_success  # TODO
  when: manual  # 暂改为手动触发，由于目前大部分项目单元测试都未完成
  dependencies: []

unit_test:
  extends: .unit_test
  stage: unit_test
  tags:
    - ci
  image: "hub.deepin.com/library/golang:bullseye"  # 需要make命令与golang环境执行go test单元测试
#  services:  # 指定附加镜像，与image容器可以相互访问，并且可以在运行作业时进行通信
#    - name: hub.deepin.com/library/mariadb:10.3.35
#      alias: mysql
#    - name: hub.deepin.com/wuhan_udcp/redis:5.0.9
#      alias: redis
#      command: ["redis-server", "--requirepass", "Udcp2022cs"]
#  variables:
#    CI_DEBUG_SERVICES: "true"  # 启用服务日志记录
#    FF_NETWORK_PER_BUILD: "true"  # 启用容器到容器的网络
#    MARIADB_DATABASE: udcp_test  # mariadb默认库
#    MARIADB_ROOT_PASSWORD: Udcp2022cs  # mariadb默认root用户密码
  before_script:
    - echo "unit_test before"
    - !reference [.common, before_script]
  script:
    - make unit_test
  after_script:
    - echo "unit_test after"
    - !reference [.failure_notify, after_script]
  artifacts:
    paths:
      - cover.out
      - cover.txt
      - cover.html
  coverage: '/total coverage: \d+\.\d+/'
